# Coveo AnalyticsSuggestions Component (CoveoAnalyticsSuggestions)

The AnalyticsSuggestion component provides query suggestions based on the queries that a Coveo Analytics service most commonly logs.

This component orders possible query suggestions by their respective number of successful item views, thus prioritizing the most relevant query suggestions. Consequently, when better options are available, this component does not suggest queries resulting in no clicks from users or requiring refinements.

The query suggestions appear in the Omnibox Component. The AnalyticsSuggestion component strongly relates to the Analytics component. While a user is typing in a query box, the AnalyticsSuggestion component allows them to see and select the most commonly used and relevant queries.

deprecated

  This component is exposed for legacy reasons. If possible, you should avoid using this component. Instead, you should use the `Omnibox` `enableQuerySuggestAddon` option.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- selectSuggestion
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- headerTitle
- numberOfSuggestions
- omniboxZIndex

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### selectSuggestion

- selectSuggestion(suggestion: number): any

- - Defined in ui/AnalyticsSuggestions/AnalyticsSuggestions.ts :146

  Selects a currently displayed query suggestion. This implies that at least one suggestion must have been returned at least once. The suggestion parameter can either be a number (0-based index position of the query suggestion to select) or a string that matches the suggestion.

  #### Parameters

  - ##### suggestion: number

  #### Returns any

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### headerTitle

headerTitle: string

- Defined in ui/AnalyticsSuggestions/AnalyticsSuggestions.ts :65

Specifies the title of the query suggestions group in the Omnibox component. This option is not available when using the default Lightning Friendly Theme.

Default value is the localized string for `"Suggested Queries"`.

Markup configuration example(s) :

    data-header-title='foo'

### numberOfSuggestions

numberOfSuggestions: number

- Defined in ui/AnalyticsSuggestions/AnalyticsSuggestions.ts :74

Specifies the number of query suggestions to request and display in the Omnibox component.

Default value is `5` and minimum value is `1`.

Minimum

  `1`

Default

  `5`

Markup configuration example(s) :

    data-number-of-suggestions='10'

### omniboxZIndex

omniboxZIndex: number

- Defined in ui/AnalyticsSuggestions/AnalyticsSuggestions.ts :57

Specifies the z-index position at which the query suggestions render themselves in the Omnibox component. Higher values are placed first.

Default value is `52` and minimum value is `0`.

Minimum

  `0`

Default

  `52`

Markup configuration example(s) :

    data-omnibox-z-index='10'

## Constructors

### constructor

- new AnalyticsSuggestions(element: HTMLElement, options: IAnalyticsSuggestionsOptions, bindings?: IComponentBindings): AnalyticsSuggestions

- Overwrites Component.constructor

  - Defined in ui/AnalyticsSuggestions/AnalyticsSuggestions.ts :81

  Creates a new AnalyticsSuggestions component.

  Also binds event handlers so that when a user selects a suggestion, an `omniboxFromLink` usage analytics event is logged if the suggestion comes from a standalone search box, or an `omniboxAnalytics` usage analytics event is logged otherwise.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IAnalyticsSuggestionsOptions

    The options for the AnalyticsSuggestions component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns AnalyticsSuggestions